#include<iostream.h>
#include<conio.h>

class matrix
{
    private:  long  m[5][5];
	      int row,col;
    public:
	void getdata()
	{
	   cout<<"Enter the number of rows    : ";
	   cin>>row;
	   cout<<"Enter the number of columns : ";
	   cin>>col;
	   cout<<"Enter the elements of the matrix\n";

	   for(int i = 0; i < row; i++)
	   {
	       for(int j = 0; j < col; j++)
	       {
		   cin>>m[i][j];
	       }
	   }
	}

	//Other member functions

	int operator ==(matrix);
	matrix operator +(matrix);
	matrix operator -(matrix);
	friend ostream & operator << (ostream &, matrix &);
};

int matrix:: operator == ( matrix cm)
{
   int ch;
   if(row == cm.row && col == cm.col)
   {
      return 1;
   }
   return 0;
}

matrix matrix:: operator + (matrix am)
{
   matrix temp;
   for(int i = 0; i < row; i++)
   {
	for(int j = 0; j < col; j++)
	{
		temp.m[i][j] = m[i][j] + am.m[i][j];
	}
	temp.row = row;
	temp.col = col;
   }
   return temp;
}

matrix matrix:: operator - (matrix sm)
{
   matrix temp;
   for(int i = 0; i < row; i++)
   {
	for(int j = 0; j < col; j++)
	{
	      temp.m[i][j] = m[i][j] - sm.m[i][j];
	}
	temp.row = row;
	temp.col = col;
   }
   return temp;
}

ostream& operator << (ostream& fout,  matrix& d)
{
      for(int i = 0; i < d.row; i++)
      {
	 for(int j = 0; j < d.col; j++)
	 {
	    fout<< d.m[i][j];
	    cout<<"  ";
	 }
	 cout<<endl;
      }
}

void  main()
{
   matrix m1,m2,m3,m4;
   clrscr();

   m1.getdata();
   m2.getdata();

   if(m1 == m2)        //overloded == operator
   {
	m3 = m1 + m2;  //overloded + operator
	m4 = m1 - m2;  //overloded - operator

	cout<<"ADDITION OF MATRICES :"<<endl;
	cout<< m3;
	cout<<"SUBTRACTION OF MATRICES :"<<endl;

	cout<<m4;
   }
   else
   {
	cout<<"Order of the input matrices is not identical!"<<endl;
	cout<<"Try again"<<endl;
   }
   getch();
}
/*-----------------------------------------
Output
Enter the number of rows    : 2
Enter the number of columns : 2
Enter the elements of the matrix
2
4
6
8
Enter the number of rows    : 2
Enter the number of columns : 2
Enter the elements of the matrix
1
3
5
7
ADDITION OF MATRICES :
3  7
11  15
SUBTRACTION OF MATRICES :
1  1
1  1


RUN 2
Enter the number of rows    : 3
Enter the number of columns : 2
Enterrthe elements of the matrix
1
2
3
4
5
6
Enter the number of rows    : 4
Enter the number of columns : 2
Enter the elements of the matrix
1
2
3
4
5
6
7
8
Order of the input matrices is not identical!
Try again
----------------------------------------------------------*/

