#include <iostream.h>
#include <conio.h>

class listNode
{
   public:  int coef;
	    int xpow;
	    int ypow;
	    listNode *ptr;
};    //End of listNode

class poly
{
    private: listNode *head, *tail;
    public:  poly()	  //constructor
	     {
		 head = NULL;
		 tail = NULL;
	     }
	     void readPoly(void);
	     void listPoly(int, int, int);
	     friend poly operator + (poly &poly1, poly &poly2);
	     friend poly operator - (poly &poly1, poly &poly2);
	   //  friend poly operator - (poly1&, poly2&);
	     void display(void);
};       //End of poly

void poly::readPoly(void)
{
    listNode *p1=NULL;
    int cf,xp,yp, choice=1;
    while(choice == 1)
    {
	p1 = new listNode;

	cout<<"Enter coefficient, xpower and ypower"<<endl;
	cin>>p1->coef>>p1->xpow>>p1->ypow;

	listPoly(p1->coef,p1->xpow,p1->ypow);

	cout<<"Do you want to continue(type 1 or 0)?"<<endl;
	cin>>choice;
    }
}

void poly::display(void)
{
   listNode *temp;
   temp = head;
   char opr = ' ';
   while(temp != NULL)
   {
       cout<<opr;
       cout<<temp->coef<<"x^"<<temp->xpow<<"y^"<<temp->ypow;
       temp=temp->ptr;
       if (temp->coef > 0)
	  opr = '+';
       else
	  opr = ' ';
   }
   cout<<"\n";
}

void poly::listPoly(int cf, int xp,int yp)
{
   listNode *rp;

   rp = new listNode;
   rp->coef = cf;
   rp->xpow = xp;
   rp->ypow = yp;
   rp->ptr = NULL;

   if (head == NULL)
   {
       head = rp;
       tail = head;
       return;
    }
    tail->ptr = rp;
    tail = rp;
}

poly operator + (poly &poly1, poly &poly2)
{
   poly temp1, temp2, tpoly;
   int a1,a2,b1,b2,c1,c2;

   temp1.head = poly1.head;
   temp2.head = poly2.head;

   while(poly1.head != NULL && poly2.head != NULL)
   {
       a1 = (poly1.head)->xpow;
       a2 = (poly2.head)->xpow;
       b1 = (poly1.head)->ypow;
       b2 = (poly2.head)->ypow;
       c1 = (poly1.head)->coef;
       c2 = (poly2.head)->coef;

       if (a1==a2 && b1==b2)
       {
	  tpoly.listPoly(c1+c2, a1,b1);
	  poly1.head = (poly1.head)->ptr;
	  poly2.head = (poly2.head)->ptr;
       }
       else if (a1 > a2 || (a1==a2 && b1>b2))
       {
	  tpoly.listPoly(c1,a1,b1);
	  poly1.head = (poly1.head)->ptr;
       }
       else
       {
	   tpoly.listPoly(c2,a1,b1);
	   poly2.head = (poly2.head)->ptr;
       }
   }
   if (poly1.head != NULL)
   {
	   while(poly1.head != NULL)
	   {
	       tpoly.listPoly((poly1.head)->coef,
		       (poly1.head)->xpow, (poly1.head)->ypow);
	       poly1.head = (poly1.head)->ptr;
	    }
   }
   else if (poly2.head != NULL)
   {
	   while(poly2.head != NULL)
	   {
	       tpoly.listPoly((poly2.head)->coef,
		       (poly2.head)->xpow, (poly2.head)->ypow);
	       poly2.head = (poly2.head)->ptr;
	    }
    }
    poly1.head = temp1.head;
    poly2.head = temp2.head;
    return tpoly;
}

//Overloaded minus operator
poly operator - (poly &poly1, poly &poly2)
{
   poly temp1, temp2, tpoly;
   int a1,a2,b1,b2,c1,c2;

   temp1.head = poly1.head;
   temp2.head = poly2.head;

   while(poly1.head != NULL && poly2.head != NULL)
   {
       a1 = (poly1.head)->xpow;
       a2 = (poly2.head)->xpow;
       b1 = (poly1.head)->ypow;
       b2 = (poly2.head)->ypow;
       c1 = (poly1.head)->coef;
       c2 = (poly2.head)->coef;

       if (a1==a2 && b1==b2)
       {
	  tpoly.listPoly(c1-c2, a1,b1);
	  poly1.head = (poly1.head)->ptr;
	  poly2.head = (poly2.head)->ptr;
       }
       else if (a1 > a2 || (a1==a2 && b1>b2))
       {
	  tpoly.listPoly(c1,a1,b1);
	  poly1.head = (poly1.head)->ptr;
       }
       else
       {
	   tpoly.listPoly(-c2,a1,b1);
	   poly2.head = (poly2.head)->ptr;
       }
   }
   if (poly1.head != NULL)
   {
	   while(poly1.head != NULL)
	   {
	       tpoly.listPoly((poly1.head)->coef,
		       (poly1.head)->xpow, (poly1.head)->ypow);
	       poly1.head = (poly1.head)->ptr;
	    }
   }
   else if (poly2.head != NULL)
   {
	   while(poly2.head != NULL)
	   {
	       tpoly.listPoly(-(poly2.head)->coef,
		       (poly2.head)->xpow, (poly2.head)->ypow);
	       poly2.head = (poly2.head)->ptr;
	    }
    }
    poly1.head = temp1.head;
    poly2.head = temp2.head;
    return tpoly;
}

void main()
{
    poly poly1,poly2,poly3,poly4;
    int choice;
    clrscr();

    cout<<"Enter the first polynomial"<<endl;
    poly1.readPoly();

    cout<<"Enter the second polynomial"<<endl;
    poly2.readPoly();

    cout<<"\nFirst polynomial is"<<endl;
    poly1.display();

    cout<<"\nSecond polynomial is"<<endl;
    poly2.display();

    poly3 = poly1 + poly2;
    cout<<"\nSum of two polynomials"<<endl;
    poly3.display();

    poly4 = poly1 - poly2;
    cout<<"\nDifference of two polynomials"<<endl;
    poly4.display();

    getch();
}
/*----------------------------------------
Output
Enter the first polynomial
Enter coefficient, xpower and ypower
3 2 2
Do you want to continue(type 1 or 0)?
1
Enter coefficient, xpower and ypower
-3 1 1
Do you want to continue(type 1 or 0)?
1
Enter coefficient, xpower and ypower
1 0 0
Do you want to continue(type 1 or 0)?
0
Enter the second polynomial
Enter coefficient, xpower and ypower
2 2 2
Do you want to continue(type 1 or 0)?
1
Enter coefficient, xpower and ypower
4 1 1
Do you want to continue(type 1 or 0)?
1
Enter coefficient, xpower and ypower
2 0 0

Do you want to continue(type 1 or 0)?
0

First polynomial is
 3x^2y^2 -3x^1y^1+1x^0y^0

Second polynomial is
 2x^2y^2+4x^1y^1+2x^0y^0

Sum of two polynomials
 5x^2y^2+1x^1y^1+3x^0y^0

Difference of two polynomials
 1x^2y^2 -7x^1y^1 -1x^0y^0
----------------------------------------------










