#include<stdio.h>
#include<conio.h>
#include<process.h>
#include<iostream.h>

//number is a single node that can hold only a single digit
//it has two links

class number
{
     private:
	    int x;
	    number *link;
	    number *previous;

     public:
	    number()
	    {
	      link = NULL;
	      previous = NULL;
	    }

	    int getnumber();
	    void setpreviouslink(number *p,number *q);
	    void setnumber(int);
	    void shownumber();
	    number* returnlink();
	    void setlink(number*);
	    number* previous_link();
};

int number::getnumber()
{
  return x;
}

void number::setnumber(int x1)
{
  x = x1;
}

void number::setlink(number *p)
{
  link = p;
}

number* number::returnlink()
{
   return link;
}

void number::shownumber()
{
  cout << x;
}

void number::setpreviouslink(number *p,number *q)
{
  if (q == NULL)
    p->previous = NULL;
  else
  {
    q->previous = p;
    p->previous = NULL;
  }
}

number* number::previous_link()
{
    return previous;
}

//linkedlist is a container class for the linkedlist

class linkedlist : public number
{
   private :
	     number *firstnumber;
	     number *secondnumber,*firsthead,*secondhead;

 //firsthead & secondhead point to the the first digits in both numbers
 //we need this to find he biggest of these during subtraction
 //firstnumber and second number point to the unit place in both numbers

	     int count1,count2;

 //these two variables keep track of the total number of digits in each number
	     number *result;

  public :
	     linkedlist();
	     void getnumber(int);
	     void add();
	     void subtract();
	     void showresult();
 };


 void linkedlist::linkedlist()
 {
       firstnumber = NULL;
       secondnumber = NULL;
       result = NULL;
       firsthead = NULL;
       secondhead = NULL;
 }


 void linkedlist::getnumber(int ch)
 {
      char c;
      int count,x1;
      number *p,*q,*z;
      p = NULL;q = NULL;

      while(1)
      {
	 fflush(stdin);
	 c = getche();

	 if (c == 13) break;
	 if ((c >= 48) && (c<= 57))
	 {
	     p = new number();

	     if ((firsthead == NULL) && (ch == 1)) firsthead = p;
	     if ((secondhead == NULL) && (ch == 2)) secondhead = p;

	     count++;
	     x1 = c - 48;
	     setpreviouslink(p,q);
	     p->setnumber(x1);
	     p->setlink(q);
	     q = p;
	 }
	 else
	 {
	     cout << "Error in input" << endl;
	     exit(0);
	 }

       }

	if (ch == 1)
	{
	     firstnumber = q;
	     count1 = count;
	}
	else
	{
	     secondnumber = q;
	     count2 = count;
	}
 }

 void linkedlist::add()
 {
      int x,carry = 0;
      number *p,*q,*link1= NULL,*temp;

      p = firstnumber;
      q = secondnumber;

      while ((p!= NULL) || (q!= NULL))
      {
	  temp = new number();

	  if (p == NULL)
	  {
	     x = q->getnumber() + carry;
	     carry = 0;

	     if(x >= 10)
	     {
		 carry = 1;
		 x = x - 10;
	     }

	     q = q->returnlink();
	     if ((p == NULL) && (carry == 1)) x = x + 10;
	  }
	  else if(q == NULL)
	  {
	     x = p->getnumber() + carry;
	     if(x >= 10)
	     {
		 carry = 1;
		 x = x - 10;
	     }
	     p = p->returnlink();
	     if ((p == NULL) && (carry == 1))
	     {
		 x = x + 10;
	     }
	  }
	  else
	  {
	     x = p->getnumber() + q->getnumber() + carry;
	     carry = 0;

	     if (x >= 10)
	     {
		  carry = 1;

		  if(((p->returnlink())== NULL) &&((q->returnlink())== NULL))
			x = x;
		  else
			x = x - 10;
	     }
	     p = p->returnlink();
	     q = q->returnlink();
	  }
     temp->setnumber(x);
     temp->setlink(link1);
     link1 = temp;
    }
    result = temp;
}
void linkedlist::subtract()
{
  number *p,*q,*temp,*link1 = NULL;
  int p1,q1,flag = 0,flag1 = 0;

  if (count1 > count2)
  {
     p = firstnumber;
     q = secondnumber;
  }
  else if (count2 > count1)
  {
     q = firstnumber;
     p = secondnumber;
     cout<<"-";
  }
  else
  {
       int x = 7;
       p = firsthead;
       q = secondhead;

       while(p != NULL)
       {
	    if ((p->getnumber()) == (q->getnumber()))
	    {
		x=0;
	    }
	    else
	    if ((q->getnumber()) > (p->getnumber()))
	    {
		x = 1;
		break;
	    }
	    else if ((p->getnumber()) > (q->getnumber()))
	    {
		x = 0;
		break;
	    }
	    p = p->previous_link();
	    q = q->previous_link();
	}
	if ( x == 1)
	{
	  q = firstnumber;
	  p = secondnumber;
	  cout<<"-";
	}
	else
	{
	  p = firstnumber;
	  q = secondnumber;
	}
    }
    while( p != NULL)
    {
       int x;
       temp = new number();
       p1 = p->getnumber();
       q1 = q->getnumber();
       if (flag)
       {
		if (p1 != 0)
		{
		  flag1 = 0;
		  p1--;
		}
		else
		{
		  p1 = 9;
		  flag1 = 1;
		}
       }
       if (q == NULL)
       {
	    q1 = 0;
       }
       if (p1 <= q1)
       {
	    if (p1 == q1)
	    {
		x = p1 - q1;
		flag = 0;
		if (flag1 == 1)
		{
		  flag = 1;
		}
	    }
	    else
	    {
		x = 10 + p1 - q1;
		flag = 1;
	    }
	}
	else
	{
	    x = p1 - q1;
	    flag = 0;
	    if (flag1 == 1)
	    {
	      flag = 1;
	    }
	}
	temp->setnumber(x);
	temp->setlink(link1);
	link1 = temp;
	p = p->returnlink();
	q = q->returnlink();

     }
     result = temp;
}

void linkedlist::showresult()
{
      number *temp;
      temp =  result;

      while((temp->returnlink()) != NULL)
      {
	  temp->shownumber();
	  temp = temp->returnlink();
      }
      temp->shownumber();
}

void main()
{

     int ch = 9;
     linkedlist *test;
     test = new linkedlist();

     clrscr();

     cout << "Enter the first number  : " ;
     test->getnumber(1);
     cout << endl;

     cout << "Enter the second number : " ;
     test->getnumber(2);
     fflush(stdin);

     cout << "\n\n";
     cout << "1-> ADDITION "<<endl;
     cout << "2-> SUBTRACTION"<<endl;

     cout << "\nEnter your choice"<<endl;
     cin >> ch;
     cout << endl;

     if ((ch != 1) && (ch!=2))
     {
	exit(0);
     }
     if (ch == 1)
     {
	cout << "SUM = " ;
	test->add();
     }
     else
     {
	cout << "DIFFERENCE = " ;
	test->subtract();
     }

     test->showresult();
     getch();
}
/*----------------------------------
Output
Enter the first number  : 321456839129
Enter the second number : 135790873461

1-> ADDITION
2-> SUBTRACTION

Enter your choice
1

RESULT = 457247712590

RUN 2
Enter the first number  : 987654321237
Enter the second number : 786543219876

1-> ADDITION
2-> SUBTRACTION

Enter your choice
2

RESULT = 201111101361

RUN3
Enter the first number  : 345678901234
Enter the second number : 567812349876

1-> ADDITION
2-> SUBTRACTION

Enter your choice
2

DIFFERENCE = -222133448642
-----------------------------------------*/



