#include <iostream.h>
#include <conio.h>
#define true 1
#define false 0
#define maxnode 10

struct binary_tree
{
     int item;
     struct binary_tree *left;
     struct binary_tree *right;
};

typedef struct binary_tree node;

class bin_tree
{
  protected:
	  node element[maxnode];
  public:
	  void create(node *record1,node *record2,int num);
	  void inorder(node *record);
	  void preorder(node *record);
	  void postorder(node *record);
};

void bin_tree::create(node *base,node *newnode,int num)
{
    while(1)
    {
       if(num == base->item)
       {
	 cout<<"Duplicate number!!\n";
	 break;
       }

       if(num > base->item)
       {
	  if(base->right == NULL)
	  {
	     base->right = newnode;
	     base = base->right;
	     break;
	  }
	  else
	  {
	     base = base->right;
	     continue;
	  }
       }
       else if(num < base->item)
       {
	  if(base->left == NULL)
	  {
		base->left = newnode;
		base = base->left;
		break;
	  }
	  else
	  {
		 base = base->left;
		 continue;
	  }
       }      //End of else if

    }         //End of while
}             //End of create

//member function to inorder traversal
void bin_tree::inorder(node *base)
{
   if(base != NULL)
   {
     inorder(base->left);
     cout<<base->item<<" ";
     inorder(base->right);
     return;
   }
}

//member function to preorder traversal
void bin_tree::preorder(node *base)
{
   if(base != NULL)
   {
     cout<<base->item<<" ";
     preorder(base->left);
     preorder(base->right);
     return;
   }
}

//member function to postorder traversal
void bin_tree::postorder(node *base)
{
   if(base!=NULL)
   {
     postorder(base->left);
     postorder(base->right);
     cout<<base->item<<" ";
     return;
   }
}

void main()
{
   int no;
   char ch = 'y';
   clrscr();
   bin_tree tree;
   node *btree, *newNode, *temp;
   btree = new node;
   btree = NULL;
   while(ch == 'y')
   {
	 cout<<"Enter the number: ";
	 cin>>no;
	 newNode = new node;
	 newNode->item = no;
	 newNode->left = NULL;
	 newNode->right = NULL;

	 if(btree == NULL)
	 {
	    *btree = *newNode;
	     btree = newNode;
	     temp = btree;
	 }
	 else
	 {
	     tree.create(temp,newNode,no);
	 }
	 cout<<"Do you want to enter more numbers(y/n)? :";
	 cin>>ch;
      }
      *temp = *btree;

      cout<<"\nINORDER TRAVERSAL\n";
      cout<<"*****************\n";
      tree.inorder(temp);

      cout<<"\n";
      cout<<"\nPREORDER TRAVERSAL\n";
      cout<<"******************\n";
      tree.preorder(temp);

      cout<<"\n";
      cout<<"\nPOSTORDER TRAVERSAL\n";
      cout<<"*******************\n";
      tree.postorder(temp);

      getch();
} 	// End of main()


/*------------------------------------------
Output
Enter the number: 10
Do you want to enter more numbers(y/n)? :y
Enter the number: 15
Do you want to enter more numbers(y/n)? :y
Enter the number: 5
Do you want to enter more numbers(y/n)? :y
Enter the number: 4
Do you want to enter more numbers(y/n)? :y
Enter the number: 18
Do you want to enter more numbers(y/n)? :n

INORDER TRAVERSAL
*****************
4 5 10 15 18

PREORDER TRAVERSAL
******************
10 5 4 15 18

POSTORDER TRAVERSAL
*******************
4 5 18 15 10

--------------------------------------------------*/