#include <iostream.h>
#include <conio.h>
#include <process.h>

class DATE
{
    private:  int dd;
	      int mm;
	      int yy;

    public:   void getdate();
	      int operator -(DATE);
	      DATE operator +(int);
};

void DATE :: getdate()
{

	cout<<"Enter a valid date(dd mm yy).... : ";
   START:
	cin>>dd>>mm>>yy;
	if((mm==2) && (dd>29))
	{
	  cout<<"Wrong input!!! ";
	  cout<<"\nEnter the date again...:";
	  goto START;
	}
	if((mm>12) || (dd>31))
	{
	   cout<<"Wrong input!!! ";
	   cout<<endl<<"Enter the date again...:";
	   goto START;
	}
	if((mm==4 || mm==6 ||mm==9 ||mm==11) && (dd>30))
	{
	   cout<<"Wrong input!!! ";
	   cout<<endl<<"Enter the date again...:";
	   goto START;
	}
	if((yy % 4)!=0 && (mm ==2) && (dd>28))
	{
	   cout<<"Wrong input!!! ";
	   cout<<endl<<"Enter the date again...:";
	   goto START;
	}

} 	 //End of getdate() member function

int DATE:: operator -(DATE d2)
{
   int i,nod1,nod2,nody,lc, no_of_days;
   nod1 = nod2 = lc =0;
   for(i=1;i< mm;i++)
   {
      if(i==1 || i== 3 || i==5 ||i==7 || i==8 || i==10 || i==12)
      {
	 nod1 = nod1 + 31;
      }
      else if(i==2)
	    nod1  = nod1 + 28;
	 else
	    nod1  = nod1 + 30;
   }
   nod1 = nod1 + dd;

   for(i=1;i< d2.mm;i++)
   {
     if(i==1 || i== 3 ||i==5 ||i==7 ||i==8 ||i==10 ||i==12)
     {
       nod2  = nod2 + 31;
     }
     else if(i==2)
	      nod2  = nod2 + 28;
	  else
	      nod2  = nod2 + 30;
   }
   nod2 = nod2 + d2.dd;
   nody = (yy - d2.yy) * 365;

   for(i = d2.yy; i<yy; i++)
   {
	if((i % 4) ==0)
	{
	    lc = lc +1;
	}
   }
   int y4 = yy-d2.yy;

   while(y4 > 400)
   {
     lc = lc + 1;
     y4 = y4 -400;
   }

   if((mm >2) && (yy % 4)==0)
   {
     lc = lc +1;
   }
   if((d2.mm >2) && (d2.yy % 4)==0)
   {
     lc = lc -1;
   }

   no_of_days = nody + nod1 - nod2 + lc;

   if (no_of_days > 0)
   {
     cout<<"Total number of days between these dates is = ";
     return (no_of_days);
   }
   else
   {
      return(no_of_days);
   }

}  //End of opertor - function


DATE DATE:: operator +(int nd)
{
    DATE dd3;

    while(nd > 365)
    {
	yy = yy+1;
	nd = nd-365;
    }

    while(nd > 30)
    {
	if(mm==1 || mm==3 || mm==5 || mm==7 || mm==8 || mm==10 || mm==12)
	{
	   nd = nd-31;
	   mm = mm+1;
	}
	else if(mm == 2)
	{
	   nd = nd-28 ;
	   mm= mm+1;
	}
	else
	{
	   nd = nd-30;
	   mm = mm+1;
	}

	if(mm > 12)
	{
	   yy = yy+1;
	   mm = 1;
	}
    }

    dd = dd + nd;
    if(dd > 30)
    {
      if(mm==4 || mm==6 ||mm==9 ||mm==11)
      {
	  mm = mm+1;
	  dd = dd -30;
      }
      else if(mm == 2)
      {
	  mm = mm+1;
	  dd = dd -28;
      }
      else if(dd > 31)
      {
	   mm = mm+1;
	   dd = dd - 31;
      }
    }
    cout<<"New date is : ";
    cout<<dd<<"-"<<mm<<"-"<<yy<<endl;
    return (dd3);
} 	//End of operator + function

void main()
{
	 DATE dd1,dd2;
	 int res,num;
	 clrscr();

     BEGIN:
	 dd1.getdate();
	 dd2.getdate();

	 res = dd1 - dd2;

	 if(res < 0)
	 {
	    cout<<"\nThe first date should be greater than second date\n";
	    cout<<"So enter the dates again..:"<<endl;
	    goto BEGIN;
	 }
	 cout<<res;
	 cout<<"\nEnter the number of days to be added to the FIRST date : ";
	 cin>>num;

	 dd2 = dd1 + num;

	 getch();
}
/*-------------------------------------------------------
Output
Enter a valid date(dd mm yy).... : 12 01 2001
Enter a valid date(dd mm yy).... : 12 01 2000
Total number of days between these dates is = 366
Enter the number of days to be added to the FIRST date : 17
New date is : 29-1-2001

RUN2
Enter a valid date(dd mm yy).... : 29 02 1999
Wrong input!!!
Enter the date again...:28 02 1999
Enter a valid date(dd mm yy).... : 32 03 1998
Wrong input!!!
Enter the date again...:31 03 1998
Total number of days between these dates is = 334
Enter the number of days to be added to the FIRST date : 3
New date is : 3-3-1999

RUN3
Enter a valid date(dd mm yy).... : 12 12 2000
Enter a valid date(dd mm yy).... : 12 01 2001

The first date should be greater than second date
So enter the dates again..:
Enter a valid date(dd mm yy).... : 12 01 2001
Enter a valid date(dd mm yy).... : 12 12 2000
Total number of days between these dates is = 31
Enter the number of days to be added to the FIRST date : 20
New date is : 1-2-2001
----------------------------------------------------------------*/







